########################################################################
#transformationTemplate.pl
#
# This file is a template you can use to start with when you build a
# ProjectConsole transformation script that will be executed as a scheduled
# task startup or shutdown command.
#
########################################################################

use PjCLib;
use Win32::OLE;
require CQPerlExt;


################
# main
################

# Global variables
$currentDate; # SQL date format
$currentTime; # SQL time format

# Initialize the date/time variables.
getCurrentDateTime();

# Get the ProjectConsole CQ session variable.
$session = logon();

myMain();
exit;

sub myMain {

    # You must always call the initializePjCLibrary() first before
    # you can use the PjCLib.
    PjCLib->initializePjCLibrary($session, PjCLib->BOOLEAN_TRUE);

    ######################################################################
    #  Your transformation code goes here

    # Sample code that prints out the physical names.  You should replace this with
    # your own code.
    PjCLib->dumpPhysicalFieldNames();
    PjCLib->dumpCQFieldNames();

    #
    ######################################################################
} # end subroutine myMain()



sub logon {

    #
    # Use the internal DashboardSystem login to get access to the Dashboard database
    #
    my $session = Win32::OLE->new('CLEARQUEST.SESSION');
    my $session = CQPerlExt::CQSession_Build();  
    $session->UserLogon("dashboardsystem", "dashboardsystem", "tstd1", "Dashboard");
    return $session;
}

# get date and set the global variables $currentDate and $currentTime
sub getCurrentDateTime {
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

    $mon = $mon + 1;
    $year = $year + 1900;

    if ($mday<10) {$mday="0$mday"; }  # add leading 0
    if ($mon<10) {$mon="0$mon"; }     # add leading 0

    # set the global variable $currentDate
    $currentDate="$year-$mon-$mday";

    # set the global variable $currentTime
    $currentTime = $hour . ":" . $min . ":" . $sec;

}

